<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.Extract"
	import="net.sf.basedb.core.BioMaterial"
	import="net.sf.basedb.core.BioMaterialEventSource"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.formatter.WellCoordinateFormatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.List"
	import="java.util.ArrayList"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%!

static int[][] QIACUBE_POSITIONS = new int[][] {
	new int[] {0, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1}, // 1 sample; pos=1
	new int[] {0, -1, -1, -1, -1, -1,  1, -1, -1, -1, -1, -1}, // 2 samples; pos=1,7
	new int[] {0, -1, -1, -1,  1, -1, -1, -1,  2, -1, -1, -1}, // 3 samples; pos=1,5,9
	new int[] {0,  1, -1, -1, -1, -1,  2,  3, -1, -1, -1, -1}, // 4 samples; pos=1,2,7,8
	new int[] {0,  1, -1, -1,  2, -1, -1,  3,  4, -1, -1, -1}, // 5 samples; pos=1,2,5,8,9
	new int[] {0,  1,  2, -1, -1, -1,  3,  4,  5, -1, -1, -1}, // 6 samples; pos=1,2,3,7,8,9
	new int[] {0,  1,  2, -1, -1,  4,  5, -1,  6,  7, -1, -1}, // 7 samples; pos=1,2,3,6,7,9,10
	new int[] {0,  1,  2,  3, -1, -1,  4,  5,  6,  7, -1, -1}, // 8 samples; pos=1,2,3,4,7,8,9,10
	new int[] {0,  1,  2, -1,  3,  4,  5, -1,  6,  7,  8, -1}, // 9 samples; pos=1,2,3,5,6,7,9,10,11
	new int[] {0,  1,  2,  3,  4, -1,  5,  6,  7,  8,  9, -1}, // 10 samples; pos=1,2,3,4,5,7,8,9,10,11
	new int[] {0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, -1}, // 11 samples; pos=1,2,3,4,5,6,7,8,9,10,11
	new int[] {0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11}  // 12 samples; pos=1,2,3,4,5,6,7,8,9,10,11,12
};

static Extract getExtractForPos(int pos, List<Extract> extracts)
{
	int index = QIACUBE_POSITIONS[extracts.size()-1][pos-1];
	return index < 0 ? null : extracts.get(index);
}

static boolean useCounterBalance(int pos, int numExtracts)
{
	return numExtracts == 1 && pos == 7 || numExtracts == 11 && pos == 12;
}
%>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final int BLOCKS_PER_PAGE = 3;
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final Extension reggie = ExtensionsControl.get(dc).getExtension("net.sf.basedb.reggie");
	final User user = User.getById(dc, sc.getLoggedInUserId());
	
	List<Extract> lysates = new ArrayList<Extract>();
	int reservedById = Values.getInt(request.getParameter("reserve"));
	AnnotationType reservedByType = reservedById > 0 ? AnnotationType.getById(dc, reservedById) : null;
	String reservedByUser = user.getName();
	for (String id : request.getParameterValues("lysates"))
	{
		Extract lysate = Extract.getById(dc, Values.getInt(id));
		if (reservedByType != null)
		{
			lysate.getAnnotationSet().getAnnotation(reservedByType).setValue(reservedByUser);
		}
		lysates.add(lysate);
	}
%>
<base:page id="protocol" type="iframe" noskin="true"
	favicon="<%=home+"/images/extraction.png"%>" 
	title="Lab Tracking Protocol for Allprep isolation">
<base:head
	scripts="~../reggie-2.js,~allprep_protocol.js" 
	styles="~../css/reggie-2.css,~../css/printable.css"
	>
	<style>
	
	table.protocolheader
	{
		width: 100%;
		border: 1px solid #000000;
		border-collapse: collapse;
		margin-bottom: 1em;
	}

	table.protocolheader tr
	{
		border-bottom: 1px solid #000000;
	}
	
	table.protocolheader > tbody > tr > th
	{
		text-align: left;
		font-size: 100%;
		background-color: #F0F0F0;
		padding: 4px;
		border-right: 1px solid #000000;
		width: 25%;
	}
	
	table.protocolheader > tbody > tr > td
	{
		border-right: 1px solid #000000;
		padding: 4px;
		width: 25%;
	}
	
	img.qiacube-map
	{
		margin: auto;
	}
	
	table.samplelist
	{
		width: 100%;
		border-collapse: collapse;
		border: 1px solid #000000;
	}
	
	table.samplelist > tbody > tr
	{
		height: 1.25cm;
	}
	
	table.samplelist > tbody > tr > th
	{
		border: 1px solid #000000;
		font-size: 1em;
	}
	
	table.samplelist > tbody > tr > td
	{
		border: 1px solid #000000;
		vertical-align: middle;
		font-size: 1em;
		padding: 0.5em;
	}
	
	.name
	{
		font-weight: bold;
		width: 20%;
		text-align: center;
	}
	.not-used
	{
		color: #999999;
		font-style: italic;
		font-weight: normal;
		text-align: center;
	}
	.box
	{
		width: 15%;
		text-align: center;
	}
	.qiacube
	{
		width: 10%;
		text-align: center;
	}
	.nanodrop
	{
		width: 10%;
		text-align: center;
	}
	table.samplelist > tbody > tr > td.remark
	{
		width: 45%;
		font-size: 0.85em;
		vertical-align: top;
	}
	
	.hide-reagents .reagent
	{
		display: none;
	}
	
	</style>
</base:head>
<base:body>

	<div class="paper">

	<form name="reggie" id="wizard">

	<div id="wizard-status"></div>

	<div id="all-protocol" style="display: none;">

	<div id="print-instructions" class="noprint fullwidth">
		<base:button id="print-button" image="<%=home+"/images/print.png"%>" title="Print&hellip;" />
		<label id="showLatestReagents" style="display: none;">
			<input type="checkbox" id="showReagents" checked>
			Include lot numbers from latest QIAcube run (<span id="latestQiaCubeDate"></span>)
		</label>
		<br clear="all">
	</div>

	<h1>Lab Tracking Protocol for Allprep isolation v.1.2 <span class="reggie">Reggie <%=reggie.getAbout().getVersion() %></span></h1>

	<table class="protocolheader">
	<tr>
		<th>Lysis date</th>
		<td></td>
		<th>Isolation date</th>
		<td></td>
	</tr>
	<tr>
		<th>Operator</th>
		<td></td>
		<th>Operator</th>
		<td></td>
	</tr>
	<tr>
		<th>RLT Plus buffer</th>
		<td><span id="rltPlusBuffer" class="reagent"></span></td>
		<th>AllPrep DNA/RNA Mini kit</th>
		<td><span id="allPrepMiniKit" class="reagent"></span></td>
	</tr>
	<tr>
		<th>Beta-Mercaptoetanol</th>
		<td><span id="betaMercaptoetanol" class="reagent"></span></td>
		<th>ETOH 70%</th>
		<td><span id="etoh70" class="reagent"></span></td>
	</tr>
	<tr>
		<th>Reagent-DX</th>
		<td><span id="reagentDx" class="reagent"></span></td>
		<th>Buffer RW1</th>
		<td><span id="bufferRw1" class="reagent"></span></td>
	</tr>
	<tr>
		<th>QIAshredder column</th>
		<td><span id="qiaShredderColumn" class="reagent"></span></td>
		<th>Buffer RPE</th>
		<td><span id="bufferRpe" class="reagent"></span></td>
	</tr>
	<tr>
		<td colspan="2" rowspan="6" style="text-align: center; font-style: italic;">
			<img src="../images/qiacube-<%=lysates.size()%>.png"><br>
			QIAcube loading chart 
		</td>
		<th>Buffer AW1</th>
		<td><span id="bufferAw1" class="reagent"></td>
	</tr>
	<tr>
		<th>Buffer AW2</th>
		<td><span id="bufferAw2" class="reagent"></td>
	</tr>
	<tr>
		<th>Buffer EB</th>
		<td><span id="bufferEb" class="reagent"></td>
	</tr>
	<tr>
		<th>RNase free water</th>
		<td><span id="rnaseFreeWater" class="reagent"></td>
	</tr>
	<tr>
		<th>AllPrep DNA Mini Spin Column</th>
		<td><span id="allPrepDnaColumn" class="reagent"></td>
	</tr>
	<tr>
		<th>RNeasy Mini Spin Column</th>
		<td><span id="rneasyColumn" class="reagent"></td>
	</tr>
	</tbody>
	</table>
	
	
	<table style="width: 100%;" class="samplelist">
	<tr>
		<th class="name">Sample</th>
		<th class="box">Storage box</th>
		<th class="qiacube">QIAcube<br>position</th>
		<th class="nanodrop">NanoDrop<br>position</th>
		<th class="remark">Remark</th>
	</tr>
	<%
	// NanoDrop positions are filled without holes
	// RNA always starts in a new column
	// There is always a "blank" well after all samples
	int ndCol = 0;
	int ndRow = 0;
	int rnaOffset = lysates.size() > 7 ? 2 : 1;
	WellCoordinateFormatter rowF = new WellCoordinateFormatter(true);
	WellCoordinateFormatter colF = new WellCoordinateFormatter(false);
	
	for (int qiacubePos = 1; qiacubePos <= 12; qiacubePos++)
	{
		Extract lysate = getExtractForPos(qiacubePos, lysates);
		if (lysate != null)
		{
			BioMaterial specimen = lysate.getParent();
			Float usedQuantity = null;
			if (specimen != null) 
			{
				BioMaterialEventSource source = lysate.getCreationEvent().getEventSource(specimen);
				usedQuantity = source.getUsedQuantity();
			}
			BioWell well = lysate.getBioWell();
			BioPlate plate = well.getPlate();
			%>
			<tr>
				<td class="name"><%=HTML.encodeTags(lysate.getName()) %></td>
				<td class="box"><%=HTML.encodeTags(plate.getName()) %> <%=well.getCoordinate() %></td>
				<td class="qiacube"><%=qiacubePos %></td>
				<td class="nanodrop"><%=rowF.format(ndRow)+colF.format(ndCol) %>/<%=rowF.format(ndRow)+colF.format(ndCol+rnaOffset) %></td>
				<td class="remark">
					<%
					if (usedQuantity != null)
					{
						%>
						ApWeight: <%=Values.formatNumber(usedQuantity / 1000, 0, "mg") %>
						<%
					}
					%>
				</td>
			</tr>
			<%
			ndRow++;
			if (ndRow == 8)
			{
				ndRow = 0;
				ndCol++;
			}
		}
		else
		{
			boolean counterbalance = useCounterBalance(qiacubePos, lysates.size());
			%>
			<tr>
				<%
				if (counterbalance)
				{
					%>
					<td class="name"><i>Counterbalance</i></td>
					<%
				}
				else
				{
					%>
					<td class="name not-used">Not used</td>
					<%
				}
				%>
				<td class="box"></td>
				<td class="qiacube <%=counterbalance ? "" : "not-used"%>"><%=qiacubePos %></td>
				<td class="nanodrop"></td>
				<td class="remark"></td>
			</tr>
			<%
		}
	}
	%>
	</table>
</div>
</form>
</div>
</base:body>
</base:page>
<%
	dc.commit();
}
finally
{
	if (dc != null) dc.close();
}
%>